
;#####################################################################################
Function Variable()
End Function

;system
Global graphx,graphx2
Global graphy,graphy2
Global graphmod
Global meshzahl
Global map_fog,map_light,rechn#

;Karte
Global tex_raum,tex_kubus,tex_kubus_masked,tex_weg
Global mesh_raum
Dim cube_mesh(20,20,20,8),cube_art(20,20,20),cube_text$(20,20,20)

;spieler
Global player_speed#,player_speed_move#
Global player_jumpower#,player_jump#,player_jump_doppel,player_jump_lad#
Global player_lichtpower,player_licht,player_licht_lad,player_licht_max,player_licht_rw#
Global player_leben,player_leben_max,player_leben_lad
Global player_posx,player_posy,player_posz
Global player_posx_alt,player_posy_alt,player_posz_alt
Global player_level

;kamera
Global cam,cam_pivot,cam_licht
Global cam_achse_y#

;sonstige
Global img_klicksor,img_rahmen
Global datei_les$
Global datei_pos
Global zufall#
Global lichtstark,kontrast
Global timer
Global les$
Global laden

;interaktion
Global einga_taste
Global einga_maus
Global mausx,mausy,mausxspeed,mausyspeed,speed
Global menu_wahl
Global mausfix

Global punkte




;#####################################################################################
Function start()
End Function

datei=OpenFile ("dat.ned")
	graphx=ReadLine(datei)
	graphy=ReadLine(datei)
	graphmod=ReadLine(datei)
	lichtstark=ReadLine(datei)
	kontrast=ReadLine(datei)
	meshzahl=ReadLine(datei)
		
	player_licht_rw=ReadLine(datei)
	player_licht_lad=ReadLine(datei)
	player_licht_max=ReadLine(datei)
	player_leben_lad=ReadLine(datei)
	player_leben_max=ReadLine(datei)
	player_jump_lad=ReadLine(datei)
	player_speed=ReadLine(datei)
	player_jump_doppel=ReadLine(datei)
CloseFile datei
AppTitle("GROOFTY")
	
HidePointer

SeedRnd(MilliSecs())

timer=CreateTimer(30)

menu_wahl=1

Grundeinstellungen()





;#####################################################################################
Function Hauptschleife()
End Function



Repeat
	
	mausx=MouseX()
	mausy=MouseY()
	mausxspeed=MouseXSpeed()
	mausyspeed=MouseYSpeed()
	If MouseHit(1) Then einga_maus=1
	If MouseHit(2) Then einga_maus=2
	If MouseHit(3) Then einga_maus=3
	If mausfix=1 Then
		If MouseX()>graphx/2+10 Then MoveMouse graphx/2,graphy/2
		If MouseX()<graphx/2-10 Then MoveMouse graphx/2,graphy/2
		If MouseY()>graphy/2+10 Then MoveMouse graphx/2,graphy/2
		If MouseY()<graphy/2-10 Then MoveMouse graphx/2,graphy/2
	EndIf
	If KeyHit(60) Then  mausfix=1-mausfix ;F2 lsst maus "frei"
	
	If menu_wahl>0 Then menu()
	
	If menu_wahl=-1 Then gamerun()
	
Until menu_wahl=0
End



;#####################################################################################

Function i________________________()
End Function





Function Grundeinstellungen()

	Graphics3D graphx,graphy,32,graphmod
	SetBuffer BackBuffer()
	SeedRnd MilliSecs()
	
	
	img_klicksor=LoadImage("img\klick.png") ;Startbild
	MaskImage img_klicksor,255,0,0
	MidHandle img_klicksor
	img_rahmen=LoadImage("img\rahmen.png") ;Textrahmen
	MaskImage img_rahmen,255,0,0
	MidHandle img_rahmen
	
	;texturen
	tex_raum=LoadTexture("img\wand1.png")
	tex_kubus=LoadTexture("img\wand2.png")
	tex_kubus_masked=LoadTexture("img\wand3.png",4)
	tex_weg=LoadTexture("img\weg.png",4)
	ScaleTexture tex_raum,0.01,0.01
	ScaleTexture tex_kubus,0.7,0.7
	ScaleTexture tex_kubus_masked,0.7,0.7

	;Hauptraum
	mesh_raum=CreateCube()
	FlipMesh mesh_raum
	FitMesh mesh_raum,0,0,0,80,80,80
	EntityTexture mesh_raum,tex_raum
	EntityType mesh_raum,3
	
	;kamera
	cam_pivot=CreatePivot()
	
	cam=CreateCamera(cam_pivot)
	cam_licht=CreateLight(2,cam)
	CameraFogMode cam,1
	CameraFogColor cam,0,0,0
	CameraFogRange cam,0.1,10
	RotateEntity cam_pivot,90,0,0
	
	player_licht_rw=1
	LightColor cam_licht,lichtstark,lichtstark,lichtstark
	LightRange cam_licht,player_licht_rw
	
	
End Function






Function Menu()
	laden=0
	ClsColor 150,150,150
	Color 0,0,0
	Cls
	
	If menu_wahl=1 Then menu_main()
	If menu_wahl=2 Then menu_setup()
	If menu_wahl=3 Then menu_grafik()
		
	Flip()
	
	If menu_wahl<=0 Then
		Datei=OpenFile ("dat.ned")
			WriteLine datei,graphx
			WriteLine datei,graphy
			WriteLine datei,graphmod
			WriteLine datei,lichtstark
			WriteLine datei,kontrast
			WriteLine datei,meshzahl
			
			WriteLine datei,player_licht_rw
			WriteLine datei,player_licht_lad
			WriteLine datei,player_licht_max
			WriteLine datei,player_leben_lad
			WriteLine datei,player_leben_max
			WriteLine datei,player_jump_lad
			WriteLine datei,player_speed
			WriteLine datei,player_jump_doppel
		CloseFile datei
		mausfix=1
	EndIf
	
End Function









Function menu_main()
	
	DrawImage img_klicksor,graphx/2,graphy/2-200
	Text graphx/2-40,graphy/2-140,"prsentiert"
	Text graphx/2-50,graphy/2-100,"G R O O F T Y"
	Text graphx/2-80,graphy/2-50,"[1] neues Spiel Starten"
	Text graphx/2-80,graphy/2-30,"[2] Laden"
	Text graphx/2-80,graphy/2-10,"[3] Setup"
	Text graphx/2-80,graphy/2+10,"[4] Grafik"
	Text graphx/2-80,graphy/2+50,"[ESC / 0] Ende"
	
	einga_taste=GetKey()
	If einga_taste=49 Then
		menu_wahl=-1
		gamestart()
	EndIf
	If einga_taste=50 Then
		menu_wahl=-1
		laden=1
		gamestart()
	EndIf
	If einga_taste=51 Then menu_wahl=2
	If einga_taste=52 Then
		menu_wahl=3
		graphx2=graphx
		graphy2=graphy
	EndIf
	If KeyHit(1) Or einga_taste=48 Then menu_wahl=0
	
	einga_taste=0
	
End Function


Function menu_grafik()
	
	Text graphx/2-80,graphy/2-100,"[1] Auflsung 800  x 600"
	Text graphx/2-80,graphy/2-80,"[2] Auflsung 1024 x 768"
	Text graphx/2-80,graphy/2-60,"[3] Auflsung 1600 x 1200"
	Text graphx/2-80,graphy/2-40,"[4] Auflsung 1920 x 1080"
	If graphmod=1 Then les="Vollbild"
	If graphmod=2 Then les="Fenster"
	Text graphx/2-80,graphy/2-20,"[5] Vollbild/Fenster, Aktuell: "+les
	If meshzahl=1 Then Text graphx/2-80,graphy/2,"[6] Systemleistung: gering"
	If meshzahl=3 Then Text graphx/2-80,graphy/2,"[6] Systemleistung: mittel"
	If meshzahl=7 Then Text graphx/2-80,graphy/2,"[6] Systemleistung: hoch"
	Text graphx/2-80,graphy/2+40,"[ESC / 0] Zurck"
	Text graphx/2-80,graphy/2+100,"Aktuell: "+graphx+" x "+graphy
	Text graphx/2-80,graphy/2+120,"gewhlt: "+graphx2+" x "+graphy2
	einga_taste=GetKey()
	If einga_taste=49 Then
		graphx2=800
		graphy2=600
	EndIf
	If einga_taste=50 Then
		graphx2=1024
		graphy2=768
	EndIf
	If einga_taste=51 Then
		graphx2=1600
		graphy2=1200
	EndIf
	If einga_taste=52 Then
		graphx2=1920
		graphy2=1080
	EndIf
	If einga_taste=53 Then graphmod=3-graphmod
	If einga_taste=54 Then
		n=meshzahl
		If n=1 Then meshzahl=3
		If n=3 Then meshzahl=7
		If n=7 Then meshzahl=1
	EndIf
	
	If KeyHit(1) Or einga_taste=48 Then
		graphx=graphx2
		graphy=graphy2
		Grundeinstellungen()
		menu_wahl=1
	EndIf
	
	einga_taste=0
		
End Function



Function menu_setup()
	
	Text graphx/2-80,graphy/2-100,"[1] Lichtstrke"
	Text graphx/2-80,graphy/2-80,"[2] Alpha"
	Text graphx/2-80,graphy/2-60,"[3] reset"
	Text graphx/2-80,graphy/2,"[ESC / 0] Zurck"
	Text graphx/2-80,graphy/2+50,"Aktuell:"
	Text graphx/2-80,graphy/2+70,"Lichtstrke: "+lichtstark+"   Alha: "+kontrast
	einga_taste=GetKey()
	If einga_taste=49 Then
		Text graphx/2-80,graphy/2-40,"Lichtstrke eingeben, Werte zwischen 1-100"
		Flip()
		Locate graphx/2-80,graphy/2-20
		les=Input()
		If les<1 Or les>4 Then
			lichtstark=1
		Else 
			lichtstark=les
		EndIf
	EndIf
	If einga_taste=50 Then
		Text graphx/2-80,graphy/2-40,"Alphawert eingeben, Werte zwischen 1-4"
		Flip()
		Locate graphx/2-80,graphy/2-20
		les=Input()
		If les<1 Or les>4 Then
			kontrast=1
		Else 
			kontrast=les
		EndIf
	EndIf
	If einga_taste=51 Then
		kontrast=1
		lichtstark=1
	EndIf
	
	If KeyHit(1) Or einga_taste=48 Then menu_wahl=1
	
	einga_taste=0
	
End Function





Function gamestart()

	player_leben=player_leben_max
	player_lichtpower=player_licht_max
	player_jumpower=1000
	player_level=1
	levelup(1,laden)
	AmbientLight 0,0,0
	
End Function




Function levelup(level_nummer,alt_laden=0)
	
	If alt_laden=1 Then
		load()
	Else
		level_lad(level_nummer)
	EndIf
	
	LightColor cam_licht,lichtstark*map_light,lichtstark*map_light,lichtstark*map_light
	CameraFogRange cam,0.1,map_fog
	For z=1 To 20
		For y=1 To 20	
			For x=1 To 20
				;lschen
				If level_nummer>1 Then 	
					For n=0 To 7
						If cube_mesh(x,y,z,n)<>0 Then
							FreeEntity cube_mesh(x,y,z,n)
							cube_mesh(x,y,z,n)=0
						EndIf
					Next
				EndIf
						
				;erstellen
				If cube_art(x,y,z)=1 Then ;normaler Cube
					cube_mesh(x,y,z,1)=CreateCube()
					EntityTexture cube_mesh(x,y,z,1),tex_kubus
					FitMesh cube_mesh(x,y,z,1),(x*4)-4,(y*4)-4,(z*4)-4,4,4,4
					EntityType cube_mesh(x,y,z,1),2
					EntityBox cube_mesh(x,y,z,1),(x*4)-4,(y*4)-4,(z*4)-4,4,4,4
				EndIf
				If cube_art(x,y,z)=3 Then ;Startposititon
					ResetEntity cam_pivot
					PositionEntity cam_pivot,(x*4)-2,(y*4)-2,(z*4)-2
					EntityType cam_pivot,1
					EntityRadius cam_pivot,1.5
				EndIf
				If cube_art(x,y,z)=4 Then ;level up
					cube_mesh(x,y,z,1)=LoadSprite("img\level.png",4)
					PositionEntity cube_mesh(x,y,z,1),(x*4)-2,(y*4)-2,(z*4)-3
					ScaleSprite cube_mesh(x,y,z,1),0.5,0.5
					SpriteViewMode cube_mesh(x,y,z,1),1
				EndIf
				If cube_art(x,y,z)=5 Then ;Lichtkristall
					cube_mesh(x,y,z,0)=CreateLight(2)
					LightRange cube_mesh(x,y,z,0),2
					PositionEntity cube_mesh(x,y,z,0),(x*4)-2,(y*4)-2,(z*4)-2
					LightColor cube_mesh(x,y,z,0),50,50,80
					For a=1 To meshzahl
						cube_mesh(x,y,z,a)=LoadMesh("mesh\kristall.3ds")
						EntityAlpha cube_mesh(x,y,z,a),0.8
						EntityShininess cube_mesh(x,y,z,a),1
						PositionEntity cube_mesh(x,y,z,a),(x*4)-Rnd(0.2,3.8),(y*4)-Rnd(0.2,3.8),(z*4)-Rnd(3.8,4.2)
						RotateEntity cube_mesh(x,y,z,a),90,0,0
						TurnEntity cube_mesh(x,y,z,a),Rand(1,15),Rand(1,359),Rand(1,15)
						zufall=Rnd(0.1,0.4)
						ScaleEntity cube_mesh(x,y,z,a),zufall,Rnd(0.1,0.5),zufall
					Next
				EndIf
				If cube_art(x,y,z)=6 Then ;Vulkan
					cube_mesh(x,y,z,1)=CreateLight(2)
					LightRange cube_mesh(x,y,z,1),1
					PositionEntity cube_mesh(x,y,z,1),(x*4)-2,(y*4)-2,(z*4)-2
					LightColor cube_mesh(x,y,z,1),150,80,80
					cube_mesh(x,y,z,2)=LoadMesh("mesh\fels.3ds")
					PositionEntity cube_mesh(x,y,z,2),(x*4)-2,(y*4)-2,(z*4)-4.5
					RotateEntity cube_mesh(x,y,z,2),90,0,0
					ScaleEntity cube_mesh(x,y,z,2),0.5,0.5,0.5
				EndIf
				If cube_art(x,y,z)=7 Then ;Pilze
					For a=0 To meshzahl
						cube_mesh(x,y,z,a)=LoadMesh("mesh\pilz.3ds")
						PositionEntity cube_mesh(x,y,z,a),(x*4)-Rnd(0.2,3.8),(y*4)-Rnd(0.2,3.8),(z*4)-4
						RotateEntity cube_mesh(x,y,z,a),90,0,0
						zufall=Rnd(0.3,0.9)
						ScaleEntity cube_mesh(x,y,z,a),zufall,Rnd(0.3,0.7),zufall
					Next
				EndIf
				If cube_art(x,y,z)=8 Then ;Falle
					cube_mesh(x,y,z,1)=CreateCube()
					EntityTexture cube_mesh(x,y,z,1),tex_kubus_masked
					FitMesh cube_mesh(x,y,z,1),(x*4)-4,(y*4)-4,(z*4)-4,4,4,4
					cube_mesh(x,y,z,0)=CreateCube()
					FlipMesh cube_mesh(x,y,z,0)
					EntityTexture cube_mesh(x,y,z,0),tex_kubus_masked
					FitMesh cube_mesh(x,y,z,0),(x*4)-4,(y*4)-4,(z*4)-4,4,4,4
					cube_mesh(x,y,z,2)=LoadSprite("img\spitz.png",4)
					PositionEntity cube_mesh(x,y,z,2),(x*4)-2,(y*4)-1,(z*4)-3
					SpriteViewMode cube_mesh(x,y,z,2),2
					RotateSprite cube_mesh(x,y,z,2),0
					RotateEntity  cube_mesh(x,y,z,2),-90,-180,0
					cube_mesh(x,y,z,3)=LoadSprite("img\spitz.png",4)
					PositionEntity cube_mesh(x,y,z,3),(x*4)-2,(y*4)-1,(z*4)-3
					SpriteViewMode cube_mesh(x,y,z,3),2
					RotateSprite cube_mesh(x,y,z,3),0
					RotateEntity  cube_mesh(x,y,z,3),90,0,0
					cube_mesh(x,y,z,4)=LoadSprite("img\spitz.png",4)
					PositionEntity cube_mesh(x,y,z,4),(x*4)-2,(y*4)-2,(z*4)-3
					SpriteViewMode cube_mesh(x,y,z,4),2
					RotateSprite cube_mesh(x,y,z,4),0
					RotateEntity  cube_mesh(x,y,z,4),-90,-180,0
					cube_mesh(x,y,z,5)=LoadSprite("img\spitz.png",4)
					PositionEntity cube_mesh(x,y,z,5),(x*4)-2,(y*4)-2,(z*4)-3
					SpriteViewMode cube_mesh(x,y,z,5),2
					RotateSprite cube_mesh(x,y,z,5),0
					RotateEntity  cube_mesh(x,y,z,5),90,0,0
					cube_mesh(x,y,z,6)=LoadSprite("img\spitz.png",4)
					PositionEntity cube_mesh(x,y,z,6),(x*4)-2,(y*4)-3,(z*4)-3
					SpriteViewMode cube_mesh(x,y,z,6),2
					RotateSprite cube_mesh(x,y,z,6),0
					RotateEntity  cube_mesh(x,y,z,6),-90,-180,0
					cube_mesh(x,y,z,7)=LoadSprite("img\spitz.png",4)
					PositionEntity cube_mesh(x,y,z,7),(x*4)-2,(y*4)-3,(z*4)-3
					SpriteViewMode cube_mesh(x,y,z,7),2
					RotateSprite cube_mesh(x,y,z,7),0
					RotateEntity  cube_mesh(x,y,z,7),90,0,0
				EndIf
				If cube_art(x,y,z)=9 Then ;Unsichtbare Wand
					cube_mesh(x,y,z,1)=CreateCube()
					EntityTexture cube_mesh(x,y,z,1),tex_kubus
					FitMesh cube_mesh(x,y,z,1),(x*4)-4,(y*4)-4,(z*4)-4,4,4,4
					EntityType cube_mesh(x,y,z,1),2
					EntityBox cube_mesh(x,y,z,1),(x*4)-4,(y*4)-4,(z*4)-4,4,4,4
					rechn=kontrast
					EntityAlpha cube_mesh(x,y,z,1),rechn/10
				EndIf
				If cube_art(x,y,z)=10 Then ;pseudowand
					cube_mesh(x,y,z,1)=CreateCube()
					EntityTexture cube_mesh(x,y,z,1),tex_kubus_masked
					FitMesh cube_mesh(x,y,z,1),(x*4)-4,(y*4)-4,(z*4)-4,4,4,4
					cube_mesh(x,y,z,0)=CreateCube()
					FlipMesh cube_mesh(x,y,z,0)
					EntityTexture cube_mesh(x,y,z,0),tex_kubus_masked
					FitMesh cube_mesh(x,y,z,0),(x*4)-4,(y*4)-4,(z*4)-4,4,4,4
				EndIf
				If cube_art(x,y,z)=11 Then ;Stacheln
					cube_mesh(x,y,z,2)=LoadSprite("img\spitz.png",4)
					PositionEntity cube_mesh(x,y,z,2),(x*4)-2,(y*4)-1,(z*4)-3
					SpriteViewMode cube_mesh(x,y,z,2),2
					RotateSprite cube_mesh(x,y,z,2),0
					RotateEntity  cube_mesh(x,y,z,2),-90,-180,0
					cube_mesh(x,y,z,3)=LoadSprite("img\spitz.png",4)
					PositionEntity cube_mesh(x,y,z,3),(x*4)-2,(y*4)-1,(z*4)-3
					SpriteViewMode cube_mesh(x,y,z,3),2
					RotateSprite cube_mesh(x,y,z,3),0
					RotateEntity  cube_mesh(x,y,z,3),90,0,0
					cube_mesh(x,y,z,4)=LoadSprite("img\spitz.png",4)
					PositionEntity cube_mesh(x,y,z,4),(x*4)-2,(y*4)-2,(z*4)-3
					SpriteViewMode cube_mesh(x,y,z,4),2
					RotateSprite cube_mesh(x,y,z,4),0
					RotateEntity  cube_mesh(x,y,z,4),-90,-180,0
					cube_mesh(x,y,z,5)=LoadSprite("img\spitz.png",4)
					PositionEntity cube_mesh(x,y,z,5),(x*4)-2,(y*4)-2,(z*4)-3
					SpriteViewMode cube_mesh(x,y,z,5),2
					RotateSprite cube_mesh(x,y,z,5),0
					RotateEntity  cube_mesh(x,y,z,5),90,0,0
					cube_mesh(x,y,z,6)=LoadSprite("img\spitz.png",4)
					PositionEntity cube_mesh(x,y,z,6),(x*4)-2,(y*4)-3,(z*4)-3
					SpriteViewMode cube_mesh(x,y,z,6),2
					RotateSprite cube_mesh(x,y,z,6),0
					RotateEntity  cube_mesh(x,y,z,6),-90,-180,0
					cube_mesh(x,y,z,7)=LoadSprite("img\spitz.png",4)
					PositionEntity cube_mesh(x,y,z,7),(x*4)-2,(y*4)-3,(z*4)-3
					SpriteViewMode cube_mesh(x,y,z,7),2
					RotateSprite cube_mesh(x,y,z,7),0
					RotateEntity  cube_mesh(x,y,z,7),90,0,0
				EndIf
				If cube_art(x,y,z)=12 Then ;Ziel
					cube_mesh(x,y,z,1)=LoadSprite("img\schatz.png",4)
					PositionEntity cube_mesh(x,y,z,1),(x*4)-2,(y*4)-2,(z*4)-3
					ScaleSprite cube_mesh(x,y,z,1),0.5,0.7
					SpriteViewMode cube_mesh(x,y,z,1),1
				EndIf
				If cube_art(x,y,z)=13 Then ;Informationspunkt
					cube_mesh(x,y,z,1)=LoadSprite("img\info.png",4)
					PositionEntity cube_mesh(x,y,z,1),(x*4)-2,(y*4)-2,(z*4)-3.5
					ScaleSprite cube_mesh(x,y,z,1),0.1,0.1
					SpriteViewMode cube_mesh(x,y,z,1),1
				EndIf
				If cube_art(x,y,z)=14 Then ;Brcke Y
					cube_mesh(x,y,z,1)=CreateCube()
					RotateEntity  cube_mesh(x,y,z,1),0,0,0
					ScaleEntity cube_mesh(x,y,z,1),2,2,0.1
					PositionEntity cube_mesh(x,y,z,1),(x*4)-2,(y*4)-2,(z*4)-4.09
					EntityTexture cube_mesh(x,y,z,1),tex_weg
					EntityType cube_mesh(x,y,z,1),2
				EndIf
				If cube_art(x,y,z)=15 Then ;Brcke X
					cube_mesh(x,y,z,1)=CreateCube()
					RotateEntity  cube_mesh(x,y,z,1),0,0,90
					ScaleEntity cube_mesh(x,y,z,1),2,2,0.1
					PositionEntity cube_mesh(x,y,z,1),(x*4)-2,(y*4)-2,(z*4)-4.09
					EntityTexture cube_mesh(x,y,z,1),tex_weg
					EntityType cube_mesh(x,y,z,1),2
				EndIf
				If cube_art(x,y,z)=16 Then ;speichern
					cube_mesh(x,y,z,1)=LoadSprite("img\save.png",4)
					PositionEntity cube_mesh(x,y,z,1),(x*4)-2,(y*4)-2,(z*4)-3
					ScaleSprite cube_mesh(x,y,z,1),0.5,0.5
					SpriteViewMode cube_mesh(x,y,z,1),1
				EndIf
				If cube_art(x,y,z)=17 Then ;Pfeiler
					cube_mesh(x,y,z,1)=CreateCylinder(12,1)
					RotateEntity  cube_mesh(x,y,z,1),90,0,0
					EntityTexture cube_mesh(x,y,z,1),tex_kubus
					ScaleEntity cube_mesh(x,y,z,1),2,2,2
					PositionEntity cube_mesh(x,y,z,1),(x*4)-2,(y*4)-2,(z*4)-2
					cube_mesh(x,y,z,2)=CreateCube()
					FitMesh cube_mesh(x,y,z,2),(x*4)-4,(y*4)-4,(z*4)-4,4,4,4
					EntityType cube_mesh(x,y,z,2),2
					EntityBox cube_mesh(x,y,z,2),(x*4)-4,(y*4)-4,(z*4)-4,4,4,4
					EntityAlpha cube_mesh(x,y,z,2),0
				EndIf
				If cube_art(x,y,z)=18 Then ;Treppe Y+
					For n=0 To 3
						cube_mesh(x,y-n,z,1)=CreateCube()
						RotateEntity  cube_mesh(x,y-n,z,1),14,0,0
						ScaleEntity cube_mesh(x,y-n,z,1),2,2.1,0.1
						PositionEntity cube_mesh(x,y-n,z,1),(x*4)-2,((y-n)*4)-2.05,(z*4)-0.6-n
						EntityTexture cube_mesh(x,y-n,z,1),tex_kubus
						EntityType cube_mesh(x,y-n,z,1),4
					Next
				EndIf
				If cube_art(x,y,z)=19 Then ;Treppe Y-
					For n=0 To 3
						cube_mesh(x,y-n,z,1)=CreateCube()
						RotateEntity  cube_mesh(x,y-n,z,1),-14,0,0
						ScaleEntity cube_mesh(x,y-n,z,1),2,2.1,0.1
						PositionEntity cube_mesh(x,y-n,z,1),(x*4)-2,((y-n)*4)-2.05,(z*4)-3.6+n
						EntityTexture cube_mesh(x,y-n,z,1),tex_kubus
						EntityType cube_mesh(x,y-n,z,1),4
					Next
				EndIf
				If cube_art(x,y,z)=20 Then ;Treppe x+
					For n=0 To 3
						cube_mesh(x-n,y,z,1)=CreateCube()
						RotateEntity  cube_mesh(x-n,y,z,1),0,14,0
						ScaleEntity cube_mesh(x-n,y,z,1),2.1,2,0.1
						PositionEntity cube_mesh(x-n,y,z,1),((x-n)*4)-2.05,(y*4)-2,(z*4)-0.6-n
						EntityTexture cube_mesh(x-n,y,z,1),tex_kubus
						EntityType cube_mesh(x-n,y,z,1),4
					Next
				EndIf
				If cube_art(x,y,z)=21 Then ;Treppe x-
					For n=0 To 3
						cube_mesh(x-n,y,z,1)=CreateCube()
						RotateEntity  cube_mesh(x-n,y,z,1),0,-14,0
						ScaleEntity cube_mesh(x-n,y,z,1),2.1,2,0.1
						PositionEntity cube_mesh(x-n,y,z,1),((x-n)*4)-2.05,(y*4)-2,(z*4)-3.6+n
						EntityTexture cube_mesh(x-n,y,z,1),tex_kubus
						EntityType cube_mesh(x-n,y,z,1),4
					Next
				EndIf
				If cube_art(x,y,z)>=22 And cube_art(x,y,z)<=29 Then ;kleiner schatz
					cube_mesh(x,y,z,1)=LoadSprite("img\schatz_klein.png",4)
					PositionEntity cube_mesh(x,y,z,1),(x*4)-2,(y*4)-2,(z*4)-3
					ScaleSprite cube_mesh(x,y,z,1),0.5,0.7
					SpriteViewMode cube_mesh(x,y,z,1),1
				EndIf
			Next
		Next
	Next

End Function




Function load()
	
	datei=OpenFile("lvl\save.ned")
		player_level=ReadLine(datei)
	CloseFile datei
	
	level_lad(player_level)
	
	datei=OpenFile("lvl\save.ned")
		player_level=ReadLine(datei)
		player_posx=ReadLine(datei)
		player_posy=ReadLine(datei)
		player_posz=ReadLine(datei)
		lichtstark=ReadLine(datei)
		kontrast=ReadLine(datei)
		player_leben=ReadLine(datei)
		player_lichtpower=ReadLine(datei)
		player_jumpower=ReadLine(datei)
		player_speed_move=ReadLine(datei)
		player_jumpower=ReadLine(datei)
		player_jump=ReadLine(datei)
		player_licht_rw=ReadLine(datei)
		player_licht_lad=ReadLine(datei)
		player_licht_max=ReadLine(datei)
		player_leben_lad=ReadLine(datei)
		player_leben_max=ReadLine(datei)
		player_jump_lad=ReadLine(datei)
		player_speed=ReadLine(datei)
		player_jump_doppel=ReadLine(datei)
		
		For z=1 To 20
			For y=1 To 20	
				datei_les=ReadLine (datei)
				For x=1 To 20
					datei_pos=Instr(datei_les,";") 
					les=Left(datei_les,datei_pos)
					cube_art(x,y,z)=Left(les,Len(les)-1)
					datei_les=Right(datei_les,Len(datei_les)-datei_pos)
					If cube_art(x,y,z)=3 Then cube_art(x,y,z)=2
				Next
			Next
		Next
		cube_art(player_posx,player_posy,player_posz)=3
	CloseFile datei
	
End Function





Function level_lad(level_nummer)
		datei=OpenFile("lvl\lev"+level_nummer+".ned")
		map_fog=ReadLine(datei)
		map_light=ReadLine(datei)
		player_jump_doppel=0
		For z=1 To 20
			For y=1 To 20	
				datei_les=ReadLine (datei)
				For x=1 To 20
					cube_text(x,y,z)=""
					;auslesen der Typen
					datei_pos=Instr(datei_les,";") 
					les=Left(datei_les,datei_pos)
					n=0
					n=Instr(les,"#")
					If n>0 Then
						cube_text(x,y,z)=Mid(les,n+1,Len(les)-n-1)
						les=Left(les,Len(les)-Len(cube_text(x,y,z))-1)
					EndIf
					
					cube_art(x,y,z)=Left(les,Len(les)-1)
					datei_les=Right(datei_les,Len(datei_les)-datei_pos)
				Next
			Next
		Next
	CloseFile datei

End Function






Function save()
	
	x=player_posx
	y=player_posy
	z=player_posz
	
	If cube_mesh(x,y,z,1)<>0 Then
		FreeEntity cube_mesh(x,y,z,1)
		cube_mesh(x,y,z,1)=0
		cube_art(x,y,z)=2
	EndIf
	datei=OpenFile("lvl\save.ned")
		WriteLine datei,player_level
		WriteLine datei,x
		WriteLine datei,y
		WriteLine datei,z
		WriteLine datei,lichtstark
		WriteLine datei,kontrast
		WriteLine datei,player_leben
		WriteLine datei,player_lichtpower
		WriteLine datei,player_jumpower
		WriteLine datei,player_speed_move
		WriteLine datei,player_jumpower
		WriteLine datei,player_jump
		WriteLine datei,player_licht_rw
		WriteLine datei,player_licht_lad
		WriteLine datei,player_licht_max
		WriteLine datei,player_leben_lad
		WriteLine datei,player_leben_max
		WriteLine datei,player_jump_lad
		WriteLine datei,player_speed
		WriteLine datei,player_jump_doppel
		For z=1 To 20
			For y=1 To 20
				les=""
				For x=1 To 20
					les=les+cube_art(x,y,z)+";"
				Next
				WriteLine datei,les
			Next
		Next
		
	CloseFile datei
End Function




Function gamerun()
	
	
	
	Gameaction()
	
	move()
	
	licht()
	
	Collisions 1,2,2,2
	Collisions 1,3,2,2
	Collisions 1,4,2,3
	
	UpdateWorld
	RenderWorld
	
	HUD()
	
	ClearCollisions()
	
	If KeyHit(1) Then
		menu_wahl=1
		mausfix=0
	EndIf
		
		
End Function






Function Gameaction()
	
	player_posx=Floor(EntityX(cam_pivot)/4)+1
	player_posy=Floor(EntityY(cam_pivot)/4)+1
	player_posz=Floor(EntityZ(cam_pivot)/4)+1
	x=player_posx
	y=player_posy
	z=player_posz
	
	If player_posz=1 Then player_leben=player_leben-10
	
	n=cube_art(player_posx,player_posy,player_posz)
	If n=4 Then ;Level
		player_level=player_level+1
		levelup(player_level)
	EndIf
	If n=5 Then ;Kristall
		player_lichtpower=player_lichtpower+player_licht_lad
		If player_lichtpower>player_licht_max Then player_lichtpower=player_licht_max
	EndIf
	If n=6 Then 
		player_leben=player_leben-1
	EndIf
	If n=7 Then
		player_leben=player_leben+player_leben_lad
		If player_leben>player_leben_max Then player_leben=player_leben_max
	EndIf
	If n=8
		player_leben=player_leben-3
	EndIf
	If n=11
		player_leben=player_leben-5
	EndIf
	If n=12
		win()
	EndIf
	If n=16
		save()
	EndIf
	If n=22
		If cube_mesh(x,y,z,1)<>0 Then
			FreeEntity cube_mesh(x,y,z,1)
			cube_mesh(x,y,z,1)=0
			cube_art(x,y,z)=2
			player_licht_rw=player_licht_rw+0.2
		EndIf
	EndIf
	If n=23
		If cube_mesh(x,y,z,1)<>0 Then
			FreeEntity cube_mesh(x,y,z,1)
			cube_mesh(x,y,z,1)=0
			cube_art(x,y,z)=2
			player_licht_lad=player_licht_lad+2
		EndIf
	EndIf
	If n=24
		If cube_mesh(x,y,z,1)<>0 Then
			FreeEntity cube_mesh(x,y,z,1)
			cube_mesh(x,y,z,1)=0
			cube_art(x,y,z)=2
			player_licht_max=player_licht_max+100
		EndIf
	EndIf
	If n=25
		If cube_mesh(x,y,z,1)<>0 Then
			FreeEntity cube_mesh(x,y,z,1)
			cube_mesh(x,y,z,1)=0
			cube_art(x,y,z)=2
			player_leben_lad=player_leben_lad+2
		EndIf
	EndIf
	If n=26
		If cube_mesh(x,y,z,1)<>0 Then
			FreeEntity cube_mesh(x,y,z,1)
			cube_mesh(x,y,z,1)=0
			cube_art(x,y,z)=2
			player_leben_max=player_leben_max+15
		EndIf
	EndIf
	If n=27
		If cube_mesh(x,y,z,1)<>0 Then
			FreeEntity cube_mesh(x,y,z,1)
			cube_mesh(x,y,z,1)=0
			cube_art(x,y,z)=2
			player_jump_lad=player_jump_lad+0.3
		EndIf
	EndIf
	If n=28
		If cube_mesh(x,y,z,1)<>0 Then
			FreeEntity cube_mesh(x,y,z,1)
			cube_mesh(x,y,z,1)=0
			cube_art(x,y,z)=2
			player_speed=player_speed+0.03
		EndIf
	EndIf
	If n=29
		If cube_mesh(x,y,z,1)<>0 Then
			FreeEntity cube_mesh(x,y,z,1)
			cube_mesh(x,y,z,1)=0
			cube_art(x,y,z)=2
			player_jump_doppel=1-player_jump_doppel
		EndIf
	EndIf
	
	If player_leben<=0 Then over()
	
	player_posx_alt=player_posx
	player_posy_alt=player_posy
	player_posz_alt=player_posz
	
End Function







Function move()
		
	player_speed_move=player_speed
	If KeyDown(42) Then
		player_jumpower=player_jumpower-7
		If player_jumpower<0 Then player_jumpower=0
		If player_jumpower>0 Then
			player_speed_move=player_speed*2
		EndIf
	EndIf
	If KeyDown(17) Then MoveEntity cam_pivot,0,0,player_speed_move
	If KeyDown(31) Then MoveEntity cam_pivot,0,0,-player_speed_move
	If KeyDown(32) Then MoveEntity cam_pivot,player_speed_move,0,0
	If KeyDown(30) Then MoveEntity cam_pivot,-player_speed_move,0,0
	
	cam_achse_y=mausyspeed
	If cam_achse_y<0 And EntityPitch(cam)+cam_achse_y<=-85 Then cam_achse_y=-85-EntityPitch(cam)
	If cam_achse_y>0 And EntityPitch(cam)+cam_achse_y>=85 Then cam_achse_y=85-EntityPitch(cam)
	TurnEntity cam_pivot,0,-mausxspeed,0
	TurnEntity cam,cam_achse_y,0,0
	
	If KeyHit(57) Then
		If player_jump_doppel=1 Then
			If player_jumpower>=500 Then
				player_jump=0.3
				player_jumpower=player_jumpower-500
			EndIf
		EndIf
		If player_jump_doppel=0 Then
			If player_jumpower>=1000 Then
				player_jump=0.3
				player_jumpower=player_jumpower-1000
			EndIf
		EndIf
	EndIf
	
	player_jump=player_jump-0.01
	If player_jump<-0.2 Then player_jump=-0.2
	MoveEntity cam_pivot,0,player_jump,0
	player_jumpower=player_jumpower+player_jump_lad
	If player_jumpower>1000 Then player_jumpower=1000
		
End Function









Function Licht()

	If KeyHit(33) Then player_licht=1-player_licht
	If player_licht=1 Then
		player_licht=2
		CameraFogRange cam,0.1,map_fog+map_light
		LightColor cam_licht,lichtstark*map_light*2,lichtstark*map_light*2,lichtstark*map_light*2
		LightRange cam_licht,player_licht_rw*2
	EndIf
	If player_licht=2 Then player_lichtpower=player_lichtpower-5
	If player_lichtpower<=0 Then player_licht=-1
	If player_licht=-1 Then
		player_licht=0
		LightColor cam_licht,lichtstark*map_light,lichtstark*map_light,lichtstark*map_light
		CameraFogRange cam,0.1,map_fog
		LightRange cam_licht,player_licht_rw
	EndIf
	
End Function






Function HUD()
	
	If cube_text(player_posx,player_posy,player_posz)<>"" Then
		Color 0,0,0
		DrawImage img_rahmen,graphx/2,graphy-100
		les=cube_text(player_posx,player_posy,player_posz)
		i=0
		Repeat
			i=i+1
			n=0
			n=Instr(les,"#")
			If n>0 Then
				Text graphx/2-230,graphy-142+i*14,Left(les,n-1)
				les=Right(les,Len(les)-n)
			Else
				Text graphx/2-230,graphy-142+i*14,les
			EndIf
		Until n=0 Or i=4
	EndIf
	
	Color 255,255,255
	Rect 9,9,102,22,0
	Rect 9,49,102,22,0
	Rect 9,89,102,22,0
	rechn=player_licht_max
	rechn=(100/rechn)*player_lichtpower
	Rect 10,90,rechn,20
	Color 0,0,255
	Rect 10,10,player_jumpower/10,20
	Color 255,255,255
	If player_jump_doppel=1 Rect 60,10,1,20
	Color 0,255,0
	rechn=player_leben_max
	rechn=100/rechn*player_leben
	Rect 10,50,rechn,20
	;Text 0,0,WaitTimer(timer)+"   rend: "+TrisRendered()
	WaitTimer timer

	Flip(0)
	
End Function





Function over()
	FlushKeys()
	ClsColor 255,100,100
	Cls
	Flip()
	Cls
	Flip()
	Color 0,0,0
	n=StringWidth("G A M E   O V E R")
	Repeat
		x=Rand(1,graphx-n)
		y=Rand(1,graphy-10)
		Text  x,y,"G A M E   O V E R"
		Flip()
		Text  x,y,"G A M E   O V E R"
	Until GetKey()
	menu_wahl=1
	FlushKeys()
End Function


Function win()
	FlushKeys()
	ClsColor 255,255,100
	Cls
	Flip()
	Cls
	Flip()
	Color 0,0,0
	n=StringWidth("Gewonnen")
	Repeat
		x=Rand(1,graphx-n)
		y=Rand(1,graphy-10)
		Text  x,y,"Gewonnen"
		Flip()
		Text  x,y,"Gewonnen"
	Until GetKey()
	menu_wahl=1

	FlushKeys()
End Function





